"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const Header_1 = __importDefault(require("../Header"));
const Linear_1 = __importDefault(require("../Linear"));
const style_1 = __importDefault(require("./style"));
const env_1 = __importDefault(require("../Fn/env"));
const native_1 = require("@react-navigation/native");
;
const Container = ({ header, style = {}, styleScroll = {}, linear, children = null, safeView = true, scrollView = true, onScroll, footer, barStyle = 'dark-content', barColor = '#fff', }) => {
    const navigation = (0, native_1.useNavigation)();
    (0, react_1.useEffect)(() => {
        const unsubscribe = navigation.addListener('focus', setStatusBar);
        return unsubscribe;
    }, []);
    const setStatusBar = () => {
        if (env_1.default.isApple)
            return;
        react_native_1.StatusBar.setBackgroundColor(barColor, false);
    };
    const renderScroll = () => {
        if (scrollView) {
            if (onScroll) {
                return (react_1.default.createElement(react_native_1.ScrollView, { style: [styleScroll], onScroll: onScroll, scrollEventThrottle: 1 }, children));
            }
            return (react_1.default.createElement(react_native_1.ScrollView, { style: [styleScroll] }, children));
        }
        return children;
    };
    const renderView = () => {
        if (!header)
            return null;
        let _styles = [
            style_1.default.container,
            style
        ];
        let _header = header;
        if (linear) {
            _styles = [
                style_1.default.container,
                style,
                {
                    zIndex: 2,
                    position: 'relative',
                    backgroundColor: 'none',
                }
            ];
            if (_header.style) {
                _header.style = Object.assign(Object.assign({}, _header.style), { backgroundColor: 'none' });
            }
            else {
                _header.style = {
                    backgroundColor: 'none',
                };
            }
        }
        return (react_1.default.createElement(react_native_1.KeyboardAvoidingView, { behavior: react_native_1.Platform.OS == 'ios' ? 'padding' : 'height', style: _styles },
            react_1.default.createElement(Header_1.default, Object.assign({}, _header)),
            renderScroll(),
            footer ? (react_1.default.createElement(react_native_1.SafeAreaView, { style: [footer.style || {}] }, footer.children)) : null));
    };
    const renderFull = () => {
        if (header)
            return null;
        if (safeView) {
            return (react_1.default.createElement(react_native_1.SafeAreaView, { style: [style_1.default.container, style] }, renderScroll()));
        }
        return (react_1.default.createElement(react_native_1.View, { style: [style_1.default.container, style] }, renderScroll()));
    };
    const renderLinear = () => {
        if (!linear)
            return null;
        if (linear === true) {
            return react_1.default.createElement(Linear_1.default, null);
        }
        else {
            return react_1.default.createElement(Linear_1.default, Object.assign({}, linear));
        }
    };
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(react_native_1.StatusBar, { barStyle: barStyle, backgroundColor: barColor }),
        renderLinear(),
        renderFull(),
        renderView()));
};
exports.default = Container;
