"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const axios_1 = __importDefault(require("axios"));
const Loading_1 = __importDefault(require("../Loading"));
const Toast_1 = __importDefault(require("../Toast"));
const config_1 = __importDefault(require("../Fn/config"));
const storage_1 = require("../Fn/storage");
const react_native_device_info_1 = require("react-native-device-info");
const react_native_1 = require("react-native");
const Fetch = (url, params = {}, extend = {}) => __awaiter(void 0, void 0, void 0, function* () {
    const opts = {
        url,
        method: (extend && (extend === null || extend === void 0 ? void 0 : extend.method)) || 'post',
        baseURL: !/http/.test(url) ? config_1.default.apiHost : '',
        headers: Object.assign({ 'Content-Type': 'application/json; charset=utf-8' }, (extend.headers || {})),
        timeout: 30000,
        withCredentials: true,
        responseType: 'json',
        responseEncoding: 'utf8',
        maxContentLength: 2000,
    };
    opts.headers['X-Device-ID'] = yield (0, react_native_device_info_1.getUniqueId)();
    const $token = yield (0, storage_1.$getStorage)('$$token');
    if ($token === null || $token === void 0 ? void 0 : $token.accessToken) {
        opts.headers = Object.assign(Object.assign({}, opts.headers), { Authorization: $token.accessToken });
    }
    if (opts.method === 'post' || opts.method === 'POST') {
        opts.data = Object.assign({}, params);
    }
    else {
        opts.params = Object.assign({}, params);
    }
    const ext = {
        loading: (extend && extend.loading === false) ? false : true,
        toast: (extend && extend.toast === false) ? false : true,
    };
    (ext === null || ext === void 0 ? void 0 : ext.loading) && Loading_1.default.show();
    return new Promise((resolve, reject) => {
        (0, axios_1.default)(opts).then(res => {
            var _a, _b;
            config_1.default.debug && console.log(`______________________opts: ${JSON.stringify(opts)}\n`);
            (ext === null || ext === void 0 ? void 0 : ext.loading) && Loading_1.default.hide();
            if ((res === null || res === void 0 ? void 0 : res.data) && ((_a = res === null || res === void 0 ? void 0 : res.data) === null || _a === void 0 ? void 0 : _a.code) === 0) {
                config_1.default.debug && console.log(`______________________res: ${JSON.stringify(opts)}\n`);
                resolve(res.data.data);
            }
            else {
                if (res.data.code == 100) {
                    react_native_1.DeviceEventEmitter.emit('toLogin');
                    return;
                }
                if (ext === null || ext === void 0 ? void 0 : ext.toast)
                    Toast_1.default.show(((_b = res === null || res === void 0 ? void 0 : res.data) === null || _b === void 0 ? void 0 : _b.msg) || '网络繁忙，请稍后再试！');
                reject((res === null || res === void 0 ? void 0 : res.data) || res);
            }
        }).catch((err) => {
            (ext === null || ext === void 0 ? void 0 : ext.loading) && Loading_1.default.hide();
            config_1.default.debug && console.log(`______________________err: ${JSON.stringify(err)}\n`);
            if (ext === null || ext === void 0 ? void 0 : ext.toast)
                Toast_1.default.show((err === null || err === void 0 ? void 0 : err.message) || '网络繁忙，请稍后再试！');
            reject(err);
        });
    });
});
exports.default = Fetch;
